import typescript from '@rollup/plugin-typescript'
import resolve from '@rollup/plugin-node-resolve'
import commonjs from '@rollup/plugin-commonjs'
import copy from 'rollup-plugin-copy'
import { dts } from 'rollup-plugin-dts'
import json from '@rollup/plugin-json'
import * as glob from 'glob'
import path from 'path'

const files = glob.sync('src-apps/**/index.ts')
console.log(files)
const configs = files.map((file) => {
  const inputFile = file
  const directory = file.split('/').slice(0, -1).join('/')
  const outputDirectory = directory.replace('src-apps', 'dist/apps')
  console.log(directory)
  console.log(outputDirectory)
  /**
   * @type {import('rollup').RollupOptions}
   */
  const config = {
    input: inputFile,
    output: {
      outDir: outputDirectory,
      file: path.join(outputDirectory, 'index.mjs'),
      // format: 'cjs'
      format: 'esm',
    },
    plugins: [
      resolve(),
      commonjs(),
      typescript({
        declaration: false
      })
      // json(),
      // copy({
      //   targets: [
      //     {
      //       src: `${directory}/*.html`,
      //       dest: outputDirectory,
      //     },
      //   ],
      // }),
    ],
    external: ['sequelize', '@kevisual/router']
  }
  return config
})
export default [...configs]
