import { useConfig } from '@kevisual/use-config';
import { Sequelize } from 'sequelize';
import path from 'path';
import os from 'os';
import fs from 'fs';

const checkFileExistsSync = (filePath: string) => {
  try {
    fs.accessSync(filePath, fs.constants.F_OK);
  } catch (err) {
    return false;
  }
  return true;
};
const config = useConfig<{ flowPath: string }>();
export const envisionPath = path.join(os.homedir(), '.config', 'envision');
const configPath = path.join(os.homedir(), '.config', 'envision', 'db.sqlite');

if (!checkFileExistsSync(envisionPath)) {
  fs.mkdirSync(envisionPath, { recursive: true });
}
let flowPath = config.flowPath || configPath;
if (!path.isAbsolute(flowPath)) {
  flowPath = path.join(process.cwd(), flowPath);
}
if (!flowPath.endsWith('.sqlite')) {
  flowPath = path.join(flowPath, 'db.sqlite');
}
// connect to db
export const sequelize = new Sequelize({
  dialect: 'sqlite',
  storage: flowPath,
  // logging: false,
});
